/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.144 Revision 1.216
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.144 2005/09/12 09:20:28 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.216 2008/11/13 23:50:55 mpagano Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Maintainer: kernel-misc@gentoo.org
9# 10#
10# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
11 12
12# added functionality: 13# added functionality:
13# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
21# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
22# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
23# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
24# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
25# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
26# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
27# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
28# the patchset version for 31# the patchset version for
29# and not use it as a true package revision 32# and not use it as a true package revision
30# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
31# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
32# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
33# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
34# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
35# 39#
36# K_DEFCONFIG - Allow specifying a different defconfig target. 40# K_DEFCONFIG - Allow specifying a different defconfig target.
37# If length zero, defaults to "defconfig". 41# If length zero, defaults to "defconfig".
38# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any 42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
39# combination of "base" and "extras" 43# combination of "base" and "extras"
40# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply. 44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
41# A value of "5" would apply genpatches-2.6.12-5 to 45# A value of "5" would apply genpatches-2.6.12-5 to
42# my-sources-2.6.12.ebuild 46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
43 48
44# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 49# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
45# can be supported by the headers ebuild 50# can be supported by the headers ebuild
46 51
47# UNIPATCH_LIST - space delimetered list of patches to be applied to the 52# UNIPATCH_LIST - space delimetered list of patches to be applied to the
53# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 58# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
54# the doc dir 59# the doc dir
55# UNIPATCH_STRICTORDER - if this is set places patches into directories of 60# UNIPATCH_STRICTORDER - if this is set places patches into directories of
56# order, so they are applied in the order passed 61# order, so they are applied in the order passed
57 62
58inherit toolchain-funcs versionator multilib 63inherit eutils toolchain-funcs versionator multilib
59EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 64EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
60 pkg_preinst pkg_postinst
61 65
62# Added by Daniel Ostrow <dostrow@gentoo.org> 66# Added by Daniel Ostrow <dostrow@gentoo.org>
63# This is an ugly hack to get around an issue with a 32-bit userland on ppc64. 67# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
64# I will remove it when I come up with something more reasonable. 68# I will remove it when I come up with something more reasonable.
65[[ ${PROFILE_ARCH} == 'ppc64' ]] && CHOST='powerpc64-unknown-linux-gnu' 69[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
66 70
67export CTARGET=${CTARGET:-${CHOST}} 71export CTARGET=${CTARGET:-${CHOST}}
68if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 72if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
69 export CTARGET=${CATEGORY/cross-} 73 export CTARGET=${CATEGORY/cross-}
70fi 74fi
71 75
72HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 76HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
73LICENSE="GPL-2" 77LICENSE="GPL-2"
78
79# No need to run scanelf/strip on kernel sources/headers (bug #134453).
80RESTRICT="binchecks strip"
74 81
75# set LINUX_HOSTCFLAGS if not already set 82# set LINUX_HOSTCFLAGS if not already set
76[[ -z ${LINUX_HOSTCFLAGS} ]] && \ 83[[ -z ${LINUX_HOSTCFLAGS} ]] && \
77 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 84 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
85
86# debugging functions
87#==============================================================
88# this function exists only to help debug kernel-2.eclass
89# if you are adding new functionality in, put a call to it
90# at the start of src_unpack, or during SRC_URI/dep generation.
91debug-print-kernel2-variables() {
92 debug-print "PVR: ${PVR}"
93 debug-print "CKV: ${CKV}"
94 debug-print "OKV: ${OKV}"
95 debug-print "KV: ${KV}"
96 debug-print "KV_FULL: ${KV_FULL}"
97 debug-print "RELEASETYPE: ${RELEASETYPE}"
98 debug-print "RELEASE: ${RELEASE}"
99 debug-print "UNIPATCH_LIST_DEFAULT: ${UNIPATCH_LIST_DEFAULT} "
100 debug-print "UNIPATCH_LIST_GENPATCHES: ${UNIPATCH_LIST_GENPATCHES} "
101 debug-print "UNIPATCH_LIST: ${UNIPATCH_LIST}"
102 debug-print "S: ${S}"
103 debug-print "KERNEL_URI: ${KERNEL_URI}"
104}
78 105
79#Eclass functions only from here onwards ... 106#Eclass functions only from here onwards ...
80#============================================================== 107#==============================================================
81handle_genpatches() { 108handle_genpatches() {
82 local tarball 109 local tarball
131 158
132 RELEASE=${CKV/${OKV}} 159 RELEASE=${CKV/${OKV}}
133 RELEASE=${RELEASE/_beta} 160 RELEASE=${RELEASE/_beta}
134 RELEASE=${RELEASE/_rc/-rc} 161 RELEASE=${RELEASE/_rc/-rc}
135 RELEASE=${RELEASE/_pre/-pre} 162 RELEASE=${RELEASE/_pre/-pre}
136 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-bk} 163 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
137 RELEASETYPE=${RELEASE//[0-9]} 164 RELEASETYPE=${RELEASE//[0-9]}
138 165
139 # Now we know that RELEASE is the -rc/-bk 166 # Now we know that RELEASE is the -rc/-git
140 # and RELEASETYPE is the same but with its numerics stripped 167 # and RELEASETYPE is the same but with its numerics stripped
141 # we can work on better sorting EXTRAVERSION. 168 # we can work on better sorting EXTRAVERSION.
142 # first of all, we add the release 169 # first of all, we add the release
143 EXTRAVERSION="${RELEASE}" 170 EXTRAVERSION="${RELEASE}"
171 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
144 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}" 172 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
145 173
174 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
175 if [[ -n "${K_NOUSEPR}" ]]; then
176 # Don't add anything based on PR to EXTRAVERSION
177 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
146 if [[ -n ${K_PREPATCHED} ]]; then 178 elif [[ -n ${K_PREPATCHED} ]]; then
179 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
147 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}" 180 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
148 elif [[ "${ETYPE}" = "sources" ]]; then 181 elif [[ "${ETYPE}" = "sources" ]]; then
182 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
149 # For some sources we want to use the PV in the extra version 183 # For some sources we want to use the PV in the extra version
150 # This is because upstream releases with a completely different 184 # This is because upstream releases with a completely different
151 # versioning scheme. 185 # versioning scheme.
152 case ${PN/-*} in 186 case ${PN/-*} in
153 wolk) K_USEPV=1;; 187 wolk) K_USEPV=1;;
154 vserver) K_USEPV=1;; 188 vserver) K_USEPV=1;;
155 esac 189 esac
156 190
157 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}" 191 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
158 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}" 192 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
159 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 193 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
160 fi 194 fi
195 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
161 196
162 # The only messing around which should actually effect this is for KV_EXTRA 197 # The only messing around which should actually effect this is for KV_EXTRA
163 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else 198 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
164 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION 199 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
165 if [[ -n ${KV_EXTRA} ]]; then 200 if [[ -n ${KV_EXTRA} ]]; then
175 210
176 # we will set this for backwards compatibility. 211 # we will set this for backwards compatibility.
177 S=${WORKDIR}/linux-${KV_FULL} 212 S=${WORKDIR}/linux-${KV_FULL}
178 KV=${KV_FULL} 213 KV=${KV_FULL}
179 214
180 # -rc-bk pulls can be achieved by specifying CKV 215 # -rc-git pulls can be achieved by specifying CKV
181 # for example: 216 # for example:
182 # CKV="2.6.11_rc3_pre2" 217 # CKV="2.6.11_rc3_pre2"
183 # will pull: 218 # will pull:
184 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-bk2.bz2 219 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
185 220
186 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then 221 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
187 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 222 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
188 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2 223 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
189 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 224 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
190 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2" 225 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
191 fi 226 fi
192 227
193 if [[ ${RELEASETYPE} == -bk ]]; then 228 if [[ ${RELEASETYPE} == -git ]]; then
194 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2 229 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
195 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 230 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
196 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2" 231 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
197 fi 232 fi
198 233
199 if [[ ${RELEASETYPE} == -rc-bk ]]; then 234 if [[ ${RELEASETYPE} == -rc-git ]]; then
200 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 235 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
201 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 236 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
202 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 237 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 238 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 239 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
205 fi 240 fi
241
242 debug-print-kernel2-variables
206 243
207 handle_genpatches 244 handle_genpatches
208} 245}
209 246
210kernel_is() { 247kernel_is() {
245 282
246kernel_is_2_6() { 283kernel_is_2_6() {
247 kernel_is 2 6 || kernel_is 2 5 284 kernel_is 2 6 || kernel_is 2 5
248} 285}
249 286
250kernel_header_destdir() {
251 [[ ${CTARGET} == ${CHOST} ]] \
252 && echo /usr/include \
253 || echo /usr/${CTARGET}/include
254}
255
256# Capture the sources type and set DEPENDs 287# Capture the sources type and set DEPENDs
257if [[ ${ETYPE} == sources ]]; then 288if [[ ${ETYPE} == sources ]]; then
258 DEPEND="!build? ( sys-apps/sed 289 DEPEND="!build? ( sys-apps/sed
259 >=sys-devel/binutils-2.11.90.0.31 ) 290 >=sys-devel/binutils-2.11.90.0.31 )"
260 doc? ( app-text/docbook-sgml-utils
261 app-text/xmlto )"
262 kernel_is ge 2 6 13 && \
263 DEPEND="${DEPEND}
264 sys-fs/udev"
265 RDEPEND="${DEPEND}
266 !build? ( >=sys-libs/ncurses-5.2 291 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
267 sys-devel/make )" 292 sys-devel/make )
293 virtual/dev-manager"
268 294
269 PROVIDE="virtual/linux-sources" 295 PROVIDE="virtual/linux-sources"
270 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa" 296 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
297
271 SLOT="${PVR}" 298 SLOT="${PVR}"
272 DESCRIPTION="Sources for the Linux kernel" 299 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
273 IUSE="symlink build doc" 300 IUSE="symlink build"
274elif [[ ${ETYPE} == headers ]]; then 301elif [[ ${ETYPE} == headers ]]; then
275 DESCRIPTION="Linux system headers" 302 DESCRIPTION="Linux system headers"
276 IUSE="" 303
304 # Since we should NOT honour KBUILD_OUTPUT in headers
305 # lets unset it here.
306 unset KBUILD_OUTPUT
277 307
278 if [[ ${CTARGET} = ${CHOST} ]]; then 308 if [[ ${CTARGET} = ${CHOST} ]]; then
279 DEPEND="!virtual/os-headers" 309 DEPEND="!virtual/os-headers"
280 PROVIDE="virtual/os-headers" 310 PROVIDE="virtual/os-headers"
281 SLOT="0" 311 SLOT="0"
285else 315else
286 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 316 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
287 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 317 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
288fi 318fi
289 319
290# Unpack functions 320# Cross-compile support functions
291#============================================================== 321#==============================================================
292unpack_2_4() { 322kernel_header_destdir() {
323 [[ ${CTARGET} == ${CHOST} ]] \
324 && echo /usr/include \
325 || echo /usr/${CTARGET}/usr/include
326}
327
328cross_pre_c_headers() {
329 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
330}
331
332env_setup_xmakeopts() {
293 # Kernel ARCH != portage ARCH 333 # Kernel ARCH != portage ARCH
294 local KARCH=$(tc-arch-kernel) 334 export KARCH=$(tc-arch-kernel)
295 335
296 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE 336 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
297 # variables properly or bad things happen ! 337 # variables properly or bad things happen !
298 local xmakeopts="ARCH=${KARCH}" 338 xmakeopts="ARCH=${KARCH}"
299 if [[ ${CTARGET} != ${CHOST} ]]; then 339 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
300 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-" 340 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
301 elif type -p ${CHOST}-ar; then 341 elif type -p ${CHOST}-ar > /dev/null ; then
302 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-" 342 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
303 fi 343 fi
344 export xmakeopts
345}
304 346
305 cd "${S}" 347# Unpack functions
348#==============================================================
349unpack_2_4() {
306 # this file is required for other things to build properly, 350 # this file is required for other things to build properly,
307 # so we autogenerate it 351 # so we autogenerate it
308 make mrproper ${xmakeopts} || die "make mrproper failed" 352 make -s mrproper ${xmakeopts} || die "make mrproper failed"
309 make symlinks ${xmakeopts} || die "make symlinks failed" 353 make -s symlinks ${xmakeopts} || die "make symlinks failed"
310 make include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 354 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
311 echo ">>> version.h compiled successfully." 355 echo ">>> version.h compiled successfully."
356}
357
358unpack_2_6() {
359 # this file is required for other things to build properly, so we
360 # autogenerate it ... generate a .config to keep version.h build from
361 # spitting out an annoying warning
362 make -s mrproper ${xmakeopts} 2>/dev/null \
363 || die "make mrproper failed"
364
365 # quick fix for bug #132152 which triggers when it cannot include linux
366 # headers (ie, we have not installed it yet)
367 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
368 touch .config
369 eerror "make defconfig failed."
370 eerror "assuming you dont have any headers installed yet and continuing"
371 epause 5
372 fi
373
374 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
375 || die "make include/linux/version.h failed"
376 rm -f .config >/dev/null
312} 377}
313 378
314universal_unpack() { 379universal_unpack() {
315 cd ${WORKDIR} 380 cd ${WORKDIR}
316 unpack linux-${OKV}.tar.bz2 381 unpack linux-${OKV}.tar.bz2
382 if [[ -d "linux" ]]; then
383 mv linux linux-${KV_FULL} \
384 || die "Unable to move source tree to ${KV_FULL}."
317 if [[ "${OKV}" != "${KV_FULL}" ]]; then 385 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
318 mv linux-${OKV} linux-${KV_FULL} \ 386 mv linux-${OKV} linux-${KV_FULL} \
319 || die "Unable to move source tree to ${KV_FULL}." 387 || die "Unable to move source tree to ${KV_FULL}."
320 fi 388 fi
321 cd "${S}" 389 cd "${S}"
322 390
323 # remove all backup files 391 # remove all backup files
324 find . -iname "*~" -exec rm {} \; 2> /dev/null 392 find . -iname "*~" -exec rm {} \; 2> /dev/null
325 393
326 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox 394 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
327 use ppc && \ 395 # only do this for kernel < 2.6.27 since this file does not exist in later
396 # kernels
397 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
398 then
399 sed -i \
328 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \ 400 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
329 "${S}"/arch/ppc/Makefile 401 "${S}"/arch/ppc/Makefile
402 else
403 sed -i \
404 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
405 "${S}"/arch/powerpc/Makefile
406 fi
330} 407}
331 408
332unpack_set_extraversion() { 409unpack_set_extraversion() {
333 cd "${S}" 410 cd "${S}"
334 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 411 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
335 cd ${OLDPWD} 412 cd "${OLDPWD}"
336} 413}
337 414
338# Should be done after patches have been applied 415# Should be done after patches have been applied
339# Otherwise patches that modify the same area of Makefile will fail 416# Otherwise patches that modify the same area of Makefile will fail
340unpack_fix_install_path() { 417unpack_fix_install_path() {
341 cd "${S}" 418 cd "${S}"
342 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile 419 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
343} 420}
344 421
345unpack_fix_docbook() {
346 if [[ -d ${S}/Documentation/DocBook ]]; then
347 cd "${S}"/Documentation/DocBook
348 sed -ie "s:db2:docbook2:g" Makefile
349 cd ${OLDPWD}
350 fi
351}
352
353# Compile Functions 422# Compile Functions
354#============================================================== 423#==============================================================
355compile_headers() { 424compile_headers() {
356 # Since KBUILD_OUTPUT shouldnt be used when compiling headers, lets unset it 425 env_setup_xmakeopts
357 # if it exists.
358 [[ -n ${KBUILD_OUTPUT} ]] && unset KBUILD_OUTPUT
359 426
360 # if we couldnt obtain HOSTCFLAGS from the Makefile, 427 # if we couldnt obtain HOSTCFLAGS from the Makefile,
361 # then set it to something sane 428 # then set it to something sane
362 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile) 429 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
363 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 430 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
364 431
365 # Kernel ARCH != portage ARCH
366 local KARCH=$(tc-arch-kernel)
367
368 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
369 # variables properly or bad things happen !
370 local xmakeopts="ARCH=${KARCH}"
371 if [[ ${CTARGET} != ${CHOST} ]]; then
372 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
373 elif type -p ${CHOST}-ar; then
374 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
375 fi
376
377 if kernel_is 2 4; then 432 if kernel_is 2 4; then
378 yes "" | make oldconfig ${xmakeopts} 433 yes "" | make oldconfig ${xmakeopts}
379 echo ">>> make oldconfig complete" 434 echo ">>> make oldconfig complete"
380 use sparc && make dep ${xmakeopts} 435 make dep ${xmakeopts}
381 elif kernel_is 2 6; then 436 elif kernel_is 2 6; then
437 # 2.6.18 introduces headers_install which means we dont need any
438 # of this crap anymore :D
439 kernel_is ge 2 6 18 && return 0
440
382 # autoconf.h isnt generated unless it already exists. plus, we have 441 # autoconf.h isnt generated unless it already exists. plus, we have
383 # no guarantee that any headers are installed on the system... 442 # no guarantee that any headers are installed on the system...
384 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 443 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
385 || touch include/linux/autoconf.h 444 || touch include/linux/autoconf.h
386 445
387 # if K_DEFCONFIG isn't set, force to "defconfig" 446 # if K_DEFCONFIG isn't set, force to "defconfig"
388 # needed by mips 447 # needed by mips
389 if [[ -z ${K_DEFCONFIG} ]]; then 448 if [[ -z ${K_DEFCONFIG} ]]; then
449 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
450 case ${CTARGET} in
451 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
452 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
453 *) K_DEFCONFIG="defconfig";;
454 esac
455 else
390 K_DEFCONFIG="defconfig" 456 K_DEFCONFIG="defconfig"
457 fi
391 fi 458 fi
392 459
393 # if there arent any installed headers, then there also isnt an asm 460 # if there arent any installed headers, then there also isnt an asm
394 # symlink in /usr/include/, and make defconfig will fail, so we have 461 # symlink in /usr/include/, and make defconfig will fail, so we have
395 # to force an include path with $S. 462 # to force an include path with $S.
396 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 463 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
397 ln -sf asm-${KARCH} "${S}"/include/asm 464 ln -sf asm-${KARCH} "${S}"/include/asm
465 cross_pre_c_headers && return 0
466
398 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 467 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
468 if compile_headers_tweak_config ; then
469 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
470 fi
399 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 471 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
400 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 472 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
401 fi 473 fi
402} 474}
403 475
404compile_manpages() { 476compile_headers_tweak_config() {
405 einfo "Making manpages ..." 477 # some targets can be very very picky, so let's finesse the
406 env -u ARCH make mandocs 478 # .config based upon any info we may have
479 case ${CTARGET} in
480 sh*)
481 sed -i '/CONFIG_CPU_SH/d' .config
482 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
483 return 0;;
484 esac
485
486 # no changes, so lets do nothing
487 return 1
407} 488}
408 489
409# install functions 490# install functions
410#============================================================== 491#==============================================================
411install_universal() { 492install_universal() {
412 #fix silly permissions in tarball 493 #fix silly permissions in tarball
413 cd ${WORKDIR} 494 cd ${WORKDIR}
414 chown -R root:root * 495 chown -R root:0 *
415 chmod -R a+r-w+X,u+w * 496 chmod -R a+r-w+X,u+w *
416 cd ${OLDPWD} 497 cd ${OLDPWD}
417} 498}
418 499
419install_headers() { 500install_headers() {
420 local ddir=$(kernel_header_destdir) 501 local ddir=$(kernel_header_destdir)
421 502
503 # 2.6.18 introduces headers_install which means we dont need any
504 # of this crap anymore :D
505 if kernel_is ge 2 6 18 ; then
506 env_setup_xmakeopts
507 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
508
509 # let other packages install some of these headers
510 rm -rf "${D}"/${ddir}/sound #alsa-headers
511 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
512 return 0
513 fi
514
515 # Do not use "linux/*" as that can cause problems with very long
516 # $S values where the cmdline to cp is too long
422 cd "${S}" 517 cd "${S}"
423 dodir ${ddir}/linux 518 dodir ${ddir}/linux
424 cp -ax "${S}"/include/linux/* ${D}/${ddir}/linux 519 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
425 rm -rf ${D}/${ddir}/linux/modules 520 rm -rf "${D}"/${ddir}/linux/modules
426 521
427 # Handle multilib headers and crap 522 # Handle multilib headers and crap
428 local multi_dirs="" multi_defs="" 523 local multi_dirs="" multi_defs=""
429 case $(tc-arch-kernel) in 524 case $(tc-arch-kernel) in
430 sparc64) 525 sparc64)
443 multi_dirs="s390 s390x" 538 multi_dirs="s390 s390x"
444 multi_defs="!__s390x__ __s390x__" 539 multi_defs="!__s390x__ __s390x__"
445 ;; 540 ;;
446 arm) 541 arm)
447 dodir ${ddir}/asm 542 dodir ${ddir}/asm
448 cp -ax "${S}"/include/asm/* "${D}"/${ddir}/asm 543 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
449 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch 544 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
450 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc 545 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
451 ;; 546 ;;
547 powerpc)
548 dodir ${ddir}/asm
549 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
550 if [[ -e "${S}"/include/asm-ppc ]] ; then
551 dodir ${ddir}/asm-ppc
552 cp -pPR "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
553 fi
554 ;;
452 *) 555 *)
453 dodir ${ddir}/asm 556 dodir ${ddir}/asm
454 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm 557 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
455 ;; 558 ;;
456 esac 559 esac
457 if [[ -n ${multi_dirs} ]] ; then 560 if [[ -n ${multi_dirs} ]] ; then
458 local d ml_inc="" 561 local d ml_inc=""
459 for d in ${multi_dirs} ; do 562 for d in ${multi_dirs} ; do
460 dodir ${ddir}/asm-${d} 563 dodir ${ddir}/asm-${d}
461 cp -ax "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed" 564 cp -pPR "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
462 565
463 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}" 566 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
464 multi_defs=${multi_defs#* } 567 multi_defs=${multi_defs#* }
465 done 568 done
466 create_ml_includes ${ddir}/asm ${ml_inc} 569 create_ml_includes ${ddir}/asm ${ml_inc}
467 fi 570 fi
468 571
469 if kernel_is 2 6; then 572 if kernel_is 2 6; then
470 dodir ${ddir}/asm-generic 573 dodir ${ddir}/asm-generic
471 cp -ax "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic 574 cp -pPR "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic
472 fi 575 fi
473 576
474 # clean up 577 # clean up
475 find "${D}" -name '*.orig' -exec rm -f {} \; 578 find "${D}" -name '*.orig' -exec rm -f {} \;
476 579
477 cd ${OLDPWD} 580 cd ${OLDPWD}
478} 581}
479 582
480install_sources() { 583install_sources() {
481 local doc docs file 584 local file
482 585
483 cd "${S}" 586 cd "${S}"
484 dodir /usr/src 587 dodir /usr/src
485 echo ">>> Copying sources ..." 588 echo ">>> Copying sources ..."
486 589
500 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 603 [[ -f ${FILESDIR}/../ChangeLog ]] && \
501 echo "Please check the ebuild ChangeLog for more details." \ 604 echo "Please check the ebuild ChangeLog for more details." \
502 > "${S}"/patches.txt 605 > "${S}"/patches.txt
503 fi 606 fi
504 607
505 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
506 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
507 use doc && ! use arm && ! use s390 && install_manpages
508 use doc && [[ -n ${docs} ]] && dodoc ${docs}
509
510 mv ${WORKDIR}/linux* ${D}/usr/src 608 mv ${WORKDIR}/linux* ${D}/usr/src
511}
512
513install_manpages() {
514 kernel_is lt 2 5 && return
515 sed -ie "s#/usr/local/man#${D}/usr/share/man#g" \
516 scripts/makeman Documentation/DocBook/Makefile
517 ebegin "Installing manpages"
518 env -u ARCH make installmandocs
519 eend $?
520 sed -ie "s#${D}/usr/share/man#/usr/local/man#g" \
521 scripts/makeman Documentation/DocBook/Makefile
522} 609}
523 610
524# pkg_preinst functions 611# pkg_preinst functions
525#============================================================== 612#==============================================================
526preinst_headers() { 613preinst_headers() {
536 623
537 # if we have USE=symlink, then force K_SYMLINK=1 624 # if we have USE=symlink, then force K_SYMLINK=1
538 use symlink && K_SYMLINK=1 625 use symlink && K_SYMLINK=1
539 626
540 # if we are to forcably symlink, delete it if it already exists first. 627 # if we are to forcably symlink, delete it if it already exists first.
541 if [[ -n ${K_SYMLINK} ]]; then 628 if [[ ${K_SYMLINK} > 0 ]]; then
542 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 629 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
543 MAKELINK=1 630 MAKELINK=1
544 fi 631 fi
545 632
546 # if the link doesnt exist, lets create it 633 # if the link doesnt exist, lets create it
554 641
555 # Don't forget to make directory for sysfs 642 # Don't forget to make directory for sysfs
556 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys 643 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
557 644
558 echo 645 echo
559 einfo "After installing a new kernel of any version, it is important"
560 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
561 einfo "created (X.Y is the first 2 parts of your new kernel version)"
562 echo
563 einfo "For example, this kernel will require:"
564 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
565 echo
566 einfo "If you are upgrading from a previous kernel, you may be interested" 646 elog "If you are upgrading from a previous kernel, you may be interested"
567 einfo "in the following documents:" 647 elog "in the following document:"
568 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml" 648 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
569 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
570 if kernel_is ge 2 6 13; then
571 ewarn "As of 2.6.13 the support for devfs has been removed."
572 ewarn "You will be required to either manage a static /dev"
573 ewarn "or to ensure that udev is starting on boot."
574 fi
575 echo 649 echo
576 650
577 # if K_EXTRAEINFO is set then lets display it now 651 # if K_EXTRAEINFO is set then lets display it now
578 if [[ -n ${K_EXTRAEINFO} ]]; then 652 if [[ -n ${K_EXTRAEINFO} ]]; then
579 echo ${K_EXTRAEINFO} | fmt | 653 echo ${K_EXTRAEINFO} | fmt |
580 while read -s ELINE; do einfo "${ELINE}"; done 654 while read -s ELINE; do einfo "${ELINE}"; done
581 fi 655 fi
582 656
657 # if K_EXTRAELOG is set then lets display it now
658 if [[ -n ${K_EXTRAELOG} ]]; then
659 echo ${K_EXTRAELOG} | fmt |
660 while read -s ELINE; do elog "${ELINE}"; done
661 fi
662
583 # if K_EXTRAEWARN is set then lets display it now 663 # if K_EXTRAEWARN is set then lets display it now
584 if [[ -n ${K_EXTRAEWARN} ]]; then 664 if [[ -n ${K_EXTRAEWARN} ]]; then
585 echo ${K_EXTRAEWARN} | fmt | 665 echo ${K_EXTRAEWARN} | fmt |
586 while read -s ELINE; do ewarn "${ELINE}"; done 666 while read -s ELINE; do ewarn "${ELINE}"; done
587 fi 667 fi
668
669 # optionally display security unsupported message
670 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
671 echo
672 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
673 ewarn "This means that it is likely to be vulnerable to recent security issues."
674 ewarn "For specific information on why this kernel is unsupported, please read:"
675 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
676 fi
677
678 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
679 KV_MAJOR=$(get_version_component_range 1 ${OKV})
680 KV_MINOR=$(get_version_component_range 2 ${OKV})
681 KV_PATCH=$(get_version_component_range 3 ${OKV})
682 if [[ "$(tc-arch)" = "sparc" ]] \
683 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
684 then
685 echo
686 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
687 elog "you now need to do"
688 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
689 elog "instead of just"
690 elog " make"
691 elog "to compile the kernel. For more information please browse to"
692 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
693 echo
694 fi
588} 695}
589 696
590postinst_headers() { 697postinst_headers() {
591 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 698 elog "Kernel headers are usually only used when recompiling your system libc, as"
592 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 699 elog "such, following the installation of newer headers, it is advised that you"
593 einfo "emerge glibc" 700 elog "re-merge your system libc."
594 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 701 elog "Failure to do so will cause your system libc to not make use of newer"
595 einfo "headers." 702 elog "features present in the updated kernel headers."
596} 703}
597 704
598# pkg_setup functions 705# pkg_setup functions
599#============================================================== 706#==============================================================
600setup_headers() { 707setup_headers() {
614 721
615# unipatch 722# unipatch
616#============================================================== 723#==============================================================
617unipatch() { 724unipatch() {
618 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE 725 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
619 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG 726 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak
620 727
621 # set to a standard locale to ensure sorts are ordered properly. 728 # set to a standard locale to ensure sorts are ordered properly.
622 myLC_ALL="${LC_ALL}" 729 myLC_ALL="${LC_ALL}"
623 myLANG="${LANG}" 730 myLANG="${LANG}"
624 LC_ALL="C" 731 LC_ALL="C"
626 733
627 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 734 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
628 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 735 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
629 736
630 # We're gonna need it when doing patches with a predefined patchlevel 737 # We're gonna need it when doing patches with a predefined patchlevel
738 extglob_bak=$(shopt -p extglob)
631 shopt -s extglob 739 shopt -s extglob
632 740
633 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 741 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
634 # usage can be either via an env var or by params 742 # usage can be either via an env var or by params
635 # although due to the nature we pass this within this eclass 743 # although due to the nature we pass this within this eclass
637 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 745 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
638 UNIPATCH_LIST="${@}" 746 UNIPATCH_LIST="${@}"
639 747
640 #unpack any passed tarballs 748 #unpack any passed tarballs
641 for i in ${UNIPATCH_LIST}; do 749 for i in ${UNIPATCH_LIST}; do
642 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 750 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
643 extention=${i/*./}
644 extention=${extention/:*/}
645 case ${extention} in
646 tbz2) PIPE_CMD="tar -xvjf";;
647 bz2) PIPE_CMD="tar -xvjf";;
648 tgz) PIPE_CMD="tar -xvzf";;
649 gz) PIPE_CMD="tar -xvzf";;
650 *) eerror "Unrecognized tarball compression"
651 die "Unrecognized tarball compression";;
652 esac
653
654 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 751 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
655 unset z 752 unset z
656 STRICT_COUNT=$((10#${STRICT_COUNT} + 1)) 753 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
657 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 754 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
658 do z="${z}0"; 755 do z="${z}0";
659 done 756 done
660 PATCH_ORDER="${z}${STRICT_COUNT}" 757 PATCH_ORDER="${z}${STRICT_COUNT}"
661 758
662 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 759 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
663 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null 760 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
761 unpack ${i##*/}
762 popd >/dev/null
664 else 763 else
665 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 764 pushd "${KPATCH_DIR}" >/dev/null
765 unpack ${i##*/}
766 popd >/dev/null
666 fi 767 fi
667 768
668 if [ $? == 0 ]; then
669 einfo "${i/*\//} unpacked"
670 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 769 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
671 else
672 eerror "Failed to unpack ${i/:*/}"
673 die "unable to unpack patch tarball"
674 fi
675 else 770 else
676 extention=${i/*./} 771 extention=${i/*./}
677 extention=${extention/:*/} 772 extention=${extention/:*/}
678 PIPE_CMD="" 773 PIPE_CMD=""
679 case ${extention} in 774 case ${extention} in
744 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 839 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
745 840
746 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 841 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
747 while [ ${PATCH_DEPTH} -lt 5 ]; do 842 while [ ${PATCH_DEPTH} -lt 5 ]; do
748 echo "Attempting Dry-run:" >> ${STDERR_T} 843 echo "Attempting Dry-run:" >> ${STDERR_T}
749 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 844 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
750 echo "=======================================================" >> ${STDERR_T} 845 echo "=======================================================" >> ${STDERR_T}
751 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 846 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
752 echo "Attempting patch:" > ${STDERR_T} 847 echo "Attempting patch:" > ${STDERR_T}
753 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 848 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
754 echo "=======================================================" >> ${STDERR_T} 849 echo "=======================================================" >> ${STDERR_T}
755 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 850 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
756 eend 0 851 eend 0
757 rm ${STDERR_T} 852 rm ${STDERR_T}
758 break 853 break
759 else 854 else
760 eend 1 855 eend 1
781 for i in ${UNIPATCH_DOCS}; do 876 for i in ${UNIPATCH_DOCS}; do
782 tmp="${tmp} ${i//*\/}" 877 tmp="${tmp} ${i//*\/}"
783 cp -f ${i} ${T}/ 878 cp -f ${i} ${T}/
784 done 879 done
785 UNIPATCH_DOCS="${tmp}" 880 UNIPATCH_DOCS="${tmp}"
786 881
787 # clean up KPATCH_DIR's - fixes bug #53610 882 # clean up KPATCH_DIR's - fixes bug #53610
788 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 883 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
789 884
790 LC_ALL="${myLC_ALL}" 885 LC_ALL="${myLC_ALL}"
791 LANG="${myLANG}" 886 LANG="${myLANG}"
887 eval ${extglob_bak}
792} 888}
793 889
794# getfilevar accepts 2 vars as follows: 890# getfilevar accepts 2 vars as follows:
795# getfilevar <VARIABLE> <CONFIGFILE> 891# getfilevar <VARIABLE> <CONFIGFILE>
796# pulled from linux-info 892# pulled from linux-info
828 # ARCH_URI is the URI for all the ${ARCH}_URI patches 924 # ARCH_URI is the URI for all the ${ARCH}_URI patches
829 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH 925 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
830 926
831 ARCH_URI="" 927 ARCH_URI=""
832 ARCH_PATCH="" 928 ARCH_PATCH=""
833 ALL_ARCH="X86 PPC PPC64 SPARC MIPS ALPHA ARM HPPA AMD64 IA64 X86OBSD S390 SH" 929 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
834 930
835 for LOOP_ARCH in ${ALL_ARCH}; do 931 for LOOP_ARCH in ${ALL_ARCH}; do
836 COMPAT_URI="${LOOP_ARCH}_URI" 932 COMPAT_URI="${LOOP_ARCH}_URI"
837 COMPAT_URI="${!COMPAT_URI}" 933 COMPAT_URI="${!COMPAT_URI}"
838 934
908 return 0 1004 return 0
909} 1005}
910 1006
911headers___fix() { 1007headers___fix() {
912 # Voodoo to partially fix broken upstream headers. 1008 # Voodoo to partially fix broken upstream headers.
913 # Issues with this function should go to plasmaroo. 1009 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
914 sed -i \ 1010 sed -i \
915 -e "s/\([ "$'\t'"]\)\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/\1__\2\3\4/g;" \ 1011 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
916 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1012 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
917 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1013 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
918 -e "s/^\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/__\1\2\3/g;" \ 1014 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1015 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
919 "$@" 1016 "$@"
920} 1017}
921 1018
922# common functions 1019# common functions
923#============================================================== 1020#==============================================================
924kernel-2_src_unpack() { 1021kernel-2_src_unpack() {
925 universal_unpack 1022 universal_unpack
1023 debug-print "Doing unipatch"
926 1024
927 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \ 1025 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
928 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}" 1026 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
929 1027
1028 debug-print "Doing premake"
1029
1030 # allow ebuilds to massage the source tree after patching but before
1031 # we run misc `make` functions below
1032 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1033
1034 debug-print "Doing unpack_set_extraversion"
1035
930 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion 1036 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
931 unpack_fix_docbook
932 unpack_fix_install_path 1037 unpack_fix_install_path
933 1038
1039 # Setup xmakeopts and cd into sourcetree.
1040 env_setup_xmakeopts
1041 cd "${S}"
1042
1043 # We dont need a version.h for anything other than headers
1044 # at least, I should hope we dont. If this causes problems
1045 # take out the if/fi block and inform me please.
1046 # unpack_2_6 should now be 2.6.17 safe anyways
1047 if [[ ${ETYPE} == headers ]]; then
934 kernel_is 2 4 && unpack_2_4 1048 kernel_is 2 4 && unpack_2_4
1049 kernel_is 2 6 && unpack_2_6
1050 fi
935} 1051}
936 1052
937kernel-2_src_compile() { 1053kernel-2_src_compile() {
938 cd "${S}" 1054 cd "${S}"
939 [[ ${ETYPE} == headers ]] && compile_headers 1055 [[ ${ETYPE} == headers ]] && compile_headers
940 [[ ${ETYPE} == sources ]] && \
941 use doc && ! use arm && ! use s390 && compile_manpages
942} 1056}
943 1057
944kernel-2_pkg_preinst() { 1058kernel-2_pkg_preinst() {
945 [[ ${ETYPE} == headers ]] && preinst_headers 1059 [[ ${ETYPE} == headers ]] && preinst_headers
946} 1060}
955 [[ ${ETYPE} == headers ]] && postinst_headers 1069 [[ ${ETYPE} == headers ]] && postinst_headers
956 [[ ${ETYPE} == sources ]] && postinst_sources 1070 [[ ${ETYPE} == sources ]] && postinst_sources
957} 1071}
958 1072
959kernel-2_pkg_setup() { 1073kernel-2_pkg_setup() {
1074 if kernel_is 2 4; then
1075 if [ "$( gcc-major-version )" -eq "4" ] ; then
1076 echo
1077 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1078 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1079 ewarn "newer kernel that supports gcc-4."
1080 echo
1081 ewarn "Also be aware that bugreports about gcc-4 not working"
1082 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1083 echo
1084 epause 10
1085 fi
1086 fi
1087
1088 ABI="${KERNEL_ABI}"
960 [[ ${ETYPE} == headers ]] && setup_headers 1089 [[ ${ETYPE} == headers ]] && setup_headers
961 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1090 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
962} 1091}

Legend:
Removed from v.1.144  
changed lines
  Added in v.1.216

  ViewVC Help
Powered by ViewVC 1.1.20